Option Strict Off
Option Explicit On
Module Module1
    '===========================
    'CLASSIC INTERFACE
    '===========================
    Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" (ByVal arg1 As Integer, ByVal arg2 As String, ByVal dwFlags As Integer) As Integer
    Public Declare Function FT_GetNumDevices Lib "FTD2XX.DLL" Alias "FT_ListDevices" (ByRef arg1 As Integer, ByVal arg2 As String, ByVal dwFlags As Integer) As Integer

    Public Declare Function FT_Open Lib "FTD2XX.DLL" (ByVal intDeviceNumber As Short, ByRef lngHandle As Integer) As Integer
    Public Declare Function FT_OpenBySerialNumber Lib "FTD2XX.DLL" Alias "FT_OpenEx" (ByVal SerialNumber As String, ByVal lngFlags As Integer, ByRef lngHandle As Integer) As Integer
    Public Declare Function FT_OpenByDescription Lib "FTD2XX.DLL" Alias "FT_OpenEx" (ByVal Description As String, ByVal lngFlags As Integer, ByRef lngHandle As Integer) As Integer
    Public Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lngBaudRate As Integer) As Integer
    Public Declare Function FT_SetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal intMask As Byte, ByVal intMode As Byte) As Integer

    Public Declare Function FT_GetBitMode Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef intData As Integer) As Integer

    Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal lngHandle As Integer) As Integer

    Public Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByVal lpszBuffer As String, ByVal lngBufferSize As Integer, ByRef lngBytesWritten As Integer) As Integer

    Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal lngHandle As Integer, ByRef lpszBuffer As Byte, ByVal lngBufferSize As Integer, ByRef lngBytesReturned As Integer) As Integer


    Public Const FT_OK As Short = 0

    ' Flags for FT_ListDevices
    Public Const FT_LIST_BY_NUMBER_ONLY As Integer = &H80000000
    Public Const FT_LIST_BY_INDEX As Integer = &H40000000

    ' Flags for FT_OpenEx
    Public Const FT_OPEN_BY_SERIAL_NUMBER As Short = 1
    Public Const FT_OPEN_BY_DESCRIPTION As Short = 2

    Public lngHandle As Integer
    Public Bufptrs As Char() = New Char(3) {}

    Public lngBytesWritten As Integer
    Public d0 As Short() = New Short(27) {}
    Public initialize0 As Short() = New Short(15) {0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0}
    '                                              0  1  2  3  4  5  6  7  8  9 10 11 12  13 14 15
    'initialize0(15) = 0 'cntrol start
    'initialize0(14) = 0 'cntrol start
    'initialize0(13) = 1 'gf[^MSB+LSB
    'initialize0(12) = 0 '13=0̂Ƃ1->MSB,0->LSB
    'initialize0(11) = 0 'gWX^01
    'initialize0(10) = 0 'tF[YWX^01
    'initialize0(9) = 0 'must 0
    'initialize0(8) = 1 'REST=1 RESET disable=0
    ' initialize0(7) = 0 '1->MCLK disable
    'initialize0(6) = 0 '1->PowerDown
    'initialize0(5) = 1 '1->MSBOUT 0->DAC
    ' initialize0(4) = 0 'must 0
    ' initialize0(3) = 1 '1->MSB,0->MSB/2
    ' initialize0(2) = 0 'MUST0
    ' initialize0(1) = 0 '0->SIGN WAVE When 5=1
    ' initialize0(0) = 0 'MUST 0

    Public Freq0 As Integer() = New Integer(68) {}
    'Public Freq1 As Integer() = New Integer(68) {}
    Public f0_data As String = ""
    ' Public f1_data As String = ""
    Public ini_data As String = ""
    Public phase0_data As Short() = New Short(15) {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1}
    Public ftstatus As Integer
    Public numDevs As Integer
    Public FT_LIST_NUMBER_ONLY As Integer
    Public LoggerList As String
    Public num As Integer
    Public str As String
    'Dim init As String = &H10000000001000
    Public f0 As Decimal '= My.Settings.f0
    Public dstatus As Integer
    Public MCLK As Integer '= My.Settings.MCLK
    Public WheelValue As Integer
    Public SendData As String = ""
    Public delta_f As Integer '= My.Settings.delta_f
    Public SendText As String = ""
    Public My_serial As Integer = 99800543



    Public Function Open_USB_Device_By_Serial_Number(ByVal SerialNumber As String) As Integer

        ftstatus = FT_OpenByDescription(SerialNumber, 1, lngHandle)
        If ftstatus <> FT_OK Then
            Exit Function
        End If

    End Function
    Public Function Open_USB_Device_By_Description(ByVal Description As String) As Integer

        ftstatus = FT_OpenByDescription(Description, 2, lngHandle)
        If ftstatus <> FT_OK Then
            Exit Function
        End If

    End Function

    Public Sub Freq_SDATA(ByVal d0, ByVal fq) 'g̏݃f[^BLSB->MSB̏
        Dim i As Short
        Dim n As Short = 0
        Dim t As Short = UBound(d0)

        f0_data = ""

        If fq = 0 Then
            f0_data = f0_data & bitzero(0) '0
        Else
            f0_data = f0_data & bitzero(1) '1
        End If

        If fq = 0 Then
            f0_data = f0_data & bitzero(1) '1
        Else
            f0_data = f0_data & bitzero(0) '0
        End If

        For i = 13 To 0 Step -1 'LSBŏɏ
            If d0(i) = 1 Then
                f0_data = f0_data & bitzero(1) '1
            Else
                f0_data = f0_data & bitzero(0) '0
            End If
        Next

        f0_data = f0_data & &H5S 'I̍}
        f0_data = f0_data & &H5S 'I̍}
        f0_data = f0_data & &H5S 'I̍}
        f0_data = f0_data & &H5S 'I̍}
        f0_data = f0_data & &H1S 'Jn̍}
        'LSBIMSBJn

        If fq = 0 Then
            f0_data = f0_data & bitzero(0) '0
        Else
            f0_data = f0_data & bitzero(1) '1
        End If

        If fq = 0 Then
            f0_data = f0_data & bitzero(1) '1
        Else
            f0_data = f0_data & bitzero(0) '0
        End If

        For i = 27 To 14 Step -1 'MSBɏ
            If d0(i) = 1 Then
                f0_data = f0_data & bitzero(1) '1
            Else
                f0_data = f0_data & bitzero(0) '0
            End If
        Next

    End Sub
    Public Sub Init0_SDATA(ByVal initialize0) '邽߂̏݃f[^
        Dim i As Short

        ini_data = ""

        For i = 15 To 0 Step -1
            If initialize0(i) = 1 Then
                ini_data = ini_data & bitzero(1) '1
            Else
                ini_data = ini_data & bitzero(0) '0
            End If
        Next

    End Sub

    Public Function bitzero(ByVal data) 'SPI interfaceo͂Bf[^1bit2bitŏo
        Dim bit_data As String

        If data = 1 Then
            bit_data = &H3S & &H2S  '011 010@SCLK->1 SCLK->0
        Else
            bit_data = &H1S & &H0S  '001 000@
        End If

        Return bit_data

    End Function
    Public Function SetFrequency(ByVal data)
        Dim i As Integer
        Dim n As Integer

        ftstatus = FT_ListDevices(numDevs, "", FT_LIST_NUMBER_ONLY)
        If numDevs > 0 Then
            ftstatus = Open_USB_Device_By_Serial_Number(My_serial)
        Else
            ftstatus = FT_Open(0, lngHandle)
        End If
        ftstatus = FT_SetBitMode(lngHandle, &H7, 1)
        ftstatus = FT_SetBaudRate(lngHandle, 30000)

        f0 = data

        If f0 >= MCLK / 2000000 Then
            f0 = MCLK / 2000000 - 0.001
        End If

        If f0 < 0.001 Then
            f0 = 0.001
        End If

        dstatus = (f0 * 10 ^ 6) / MCLK * (2 ^ 28)

        ' SendText = Convert.ToString(dstatus, 2) & vbCrLf & Len(Convert.ToString(dstatus, 2))
        n = Len(Convert.ToString(dstatus, 2))

        For i = 0 To 27
            If n >= i Then
                d0(i) = Convert.ToString(dstatus And 1)
                dstatus = dstatus >> 1
            Else
                d0(i) = 0
            End If

        Next

        Freq_SDATA(d0, 0)

        'SendText = SendText & vbCrLf & "d0="

        'For i = UBound(d0) To 0 Step -1
        'SendText = SendText & d0(i)
        'If i Mod 4 = 0 Then
        'SendText = SendText & " "
        'End If
        'Next

        'SendText = SendText & vbCrLf & "init="

        'For i = UBound(initialize0) To 0 Step -1
        'SendText = SendText & initialize0(i)
        'If i Mod 4 = 0 Then
        'SendText = SendText & " "
        ' End If
        ' Next


        'f[^̓n
        'ȑÕWX^Zbg->f0LSB瑗->MSB->phase0->phase1->NO REST
        'initialize -> f0(LSB)->f0(MSB)->phase0->phase1->initialize1
        'MSB͎gf[^28bit̑OALSB͌
        '
        'SPI interfaceł̏o͕@@Function bitzeroQ
        'SCLK,SDATA,FSYNC@FT_SetBitModeŏo̓sw
        'd0   ,d1    ,d2,.....d7
        ' 1    0      1   
        ' 1    0      1   
        ' 1    0      1   f[^nȌ
        ' 1    0      0   f[^Jn̍}
        ' 1    x      0   f[^aACLSK ANeBu
        ' 0    x      0   f[^aAŃX[u擾
        ' 1    x      0   ̃f[^b
        ' 0    x      0   ̃f[^b

        lngBytesWritten = 0
        SendData = &H5S & &H5S & &H5S & &H5S & &H1S

        Init0_SDATA(initialize0)

        SendData = SendData & ini_data & &H5S & &H5S & &H5S & &H1S 'Rg[

        Freq_SDATA(d0, 0)

        SendData = SendData & f0_data & &H5S & &H5S & &H5S & &H1S 'f0f[^

        Freq_SDATA(d0, 1)

        SendData = SendData & f0_data & &H5S & &H5S & &H5S & &H1S 'f1f[^

        Init0_SDATA(phase0_data)

        SendData = SendData & ini_data & &H5S & &H5S & &H5S & &H1S 'phase0

        phase0_data(13) = 1

        Init0_SDATA(phase0_data)

        SendData = SendData & ini_data & &H5S & &H5S & &H5S & &H1S 'phase1

        initialize0(8) = 0 'REST=1 RESET disable=0

        Init0_SDATA(initialize0) '

        SendData = SendData & ini_data & &H5S & &H5S & &H5S

        SendText = SendText & vbCrLf & SendData


        If SendData.Length < 1024 Then

            ftstatus = FT_Write(lngHandle, SendData, SendData.Length, lngBytesWritten)

        Else
            LoggerList = "Write Failed status=" & ftstatus
            SendText = SendData.Length & LoggerList
        End If

        If ftstatus <> FT_OK Then
            LoggerList = "Open Failed status=" & ftstatus
            SendText = lngHandle & LoggerList
        Else
            SendText = lngBytesWritten & "written!" 'numDevs & FT_LIST_NUMBER_ONLY
        End If

        ftstatus = FT_Close(lngHandle)

        Return SendText

    End Function
End Module